{ Cosumnes River College                                   }
{ Programmer:   Group 4: Cribbs, Mok, Luciano, Weir, Young }
{ CIS31   MW    5:30pm - 6:45pm                            }
{ Assignment #8                                  50 Points }

{ This prograqm will take a list of records that contain information about
  people and find people who match their criteria and display them on the
  screen.
Last Modified:12/10/96                                        }

{Identification Division}
Program Datemake  (Input, Output);
Uses crt;

{Data Division}
   Type
     String30  = String[30];
     String12  = String[12];
     Fiver     = 1..5;
     ChoiceList= array[1..5] of string30;        {added by Ben Weir}
     ChoiceText = Record                         {.}
                Rating:     ChoiceList;          {.}
                Education:  ChoiceList;          {.}
                Income:     ChoiceList;          {.}
                Looks:      ChoiceList;          {.}
                Music:      ChoiceList;          {.}
                Empty:      ChoiceList;          {.}
              end;
     Dating = Record
                LastName    : String30;
                FirstName   : Char;
                Sex         : Boolean;
                Age         : 1..118;
                Height      : 1..96;
                Weight      : 1..1000;
                PhoneNumber : String12;
                Outdoors, Sports, Education, Income, Looks, Adventure,
                Outgoing    : Fiver;
                Easy, Drink, Smoke, Drugs : Boolean;
                Music       : Fiver;
              End;
     DataFile   = File of Dating;
     DbaseType  = Array [1..20] of Dating;
     ClientType = Dating;
     Matches    = Array [1..20] of Boolean;

{ Type Declarations }
{ String30 - A 30 character long string
{ String12 - A 12 character long string
  Fiver    - A subrange type from 1 to 5 used for the ratings in the record
  Dating   - The record with the following fields:
    LastName    - Last Name of person     Type:string30
    FirstName   - First Initial of person Type:Char
    Sex         - Male or Female          Type:Boolean (True if male)
    Age         - Age of person           Type:1..118
    Height      - Height in Inches        Type:1..96
    Weight      - Weight in Pounds        Type:1..1000
    PhoneNumber - Phone Number of person  Type: String12
    Outdoors    - How much like outdoors  Type:Fiver
    Sports      - How much like sports    Type:Fiver
    Education   - Education level         Type:Fiver
    Income      - Income of person        Type:Fiver
    Looks       - Attractiveness          Type:Fiver
    Adventure   - How adventurous         Type:Fiver
    Outgoing    - How outgoing they are   Type:Fiver
    Easy        - Are they into leather?  Type:Boolean (Y or N)
    Drink       - Do they drink?          Type:Boolean (Y or N)
    Smoke       - Do they smoke?          Type:Boolean (Y or N)
    Drugs       - Do they use drugs?      Type:Boolean (Y or N)
    Music       - Like what kind of music Type:Fiver

  DataFile   - File of the type record using Dating
  DbaseType  - Array from 1 to MaxClients of type Dating
  ClientType - Type of Dating used for client making their match
  Matches    - Array from 1 to MaxClients of type Boolean
  ChoiceList - An array used to make the criteria routine cleaner
  ChoiceText - type for the constant choice                         }

   Const
      MaxClients = 20;
      Choice: ChoiceText =
            (Rating:    ('None', 'Little', 'Some', 'Very', 'Extremely');
             Education:
            ('Less than high school', 'High school graduate', 'Some College',
             'College Degree', 'Graduate Degree');
            Income:    ('Less than $7,500', '$7,500 - $15,000',
             '$15,001 - $25,000', '$25,001 - $40,000', 'Over $40,000');
            Looks:     ('Ugly', 'Below average', 'Average', 'Above average',
             'To die for!');
            Music:     ('Rock ''N'' Roll', 'Top 40', 'Country and Western',
             'Classical', 'Other'));

{ Constant Declarations }
{ MaxClients - The last record number of the database
{ Choice     - contains the different criteria listings in a constant }

   Var
     Database          : DbaseType;
     DatingFile        : DataFile;
     Index, Match      : Integer;
     FileName          : String30;
     Client            : ClientType;
     ClientMatches     : Matches;
     ClientSearch      : Boolean;
     UsedCriteria      : Matches;
     Flag, Rerun       : Boolean;
{ Variable Definitions }
{ DataBase      - The database of all records that were on the disk
  DatingFile    - The file that contains the records
  Index         - Index used for the array
  Match         - Number of matches of the search
  FileName      - Name of the data file that the user inputs
  Client        - The record of the client doing the search for a date
  ClientMatches - a parallel array of database of type boolean
                  ( True = client matches this person )
  UsedCriteria  - An Array to check if a particular criteria is to be
                  searched (True = use that criteria
  Flag , Rerun  - 2 boolean flags to check if a condition is true or not }

{Procedure Division}

Procedure GetReady;
{ This procedure gets the data file's name and checks to see if it exists }
{ By Michael Cribbs }

Procedure FindIt;
{ This procedure looks for the file Data.dat on the A and B drives }

Var
  A : Integer;

Begin
 {$I-}           { Turn off Input/Output checking  so no run time error }
 Assign (DatingFile, 'a:\data.dat');
 Reset (DatingFile);          { See if it is on drive A: }
 If IOResult<>0 Then          { if IOResult<>0 error happened }
 Begin      { Not on A drive }
   Close(DatingFile);
   A := IOResult;
   Assign (DatingFile, 'b:\data.dat');
   Reset (DatingFile);
   If IOResult<>0 Then
   Begin { Not on disk }
     TextColor(20);
     WriteLn('Please inesrt the Datemaker 2000 disk in A or B!');
     TextColor(0);
    End { Not on Disk }
    Else
      Begin { On B }
        TextColor(4);
        WriteLn ('On the B: Drive!');
        TextColor(0);
      End; { On B }
 End { Not on A Drive }
 Else
   Begin { On A }
     TextColor(4);
     WriteLn ('On the A: Drive');
     TextColor(0);
   End; { On A }
 Close(DatingFile);
 {$I+}
End; { FindIt }

Begin { GetReady }
  TextBackground(11);
  Clrscr;
  WriteLn;
  WriteLn;
  TextColor(Yellow);
  Write ('DateMaker 2000 ');
  TextColor (Blue);
  Write ('By ');
  TextColor(Blue+Blink);
  WriteLn('Whiz-O Soft');
  WriteLn;
  WriteLn;
  TextColor(0);
  Repeat
    Write ('What is the name of the data file ($ to find):');
    ReadLn(FileName);
    If FileName = '$' Then FindIt
    Else
    Begin { Else }
    {$I-}           { Turn off Input/Output checking  so no run time error }
    Assign (DatingFile, FileName);
    Reset (DatingFile);          { Try to open FileName }
    If IOResult<>0 Then          { if IOResult<>0 error happened }
     Begin      { IO Error }
       TextColor(20);
       WriteLn('File does not exist!');
       TextColor(0);
       Close(DatingFile);        { Close File }
     End;       { IO Error }
     Close (DatingFile);
     {$I+}          { Turn compiler directive back on }
     End; { Else }
  Until IOResult=0; { Keep repeating until the file does exist }
  Flag := True;
End; { GetReady }

Procedure Encrypt (Var PhoneNumber : String12);
{ This procedure encrypts the telephone number of the records before they
  are saved on the disk.  It has 3 local varables.                        }
{ By Michael Cribbs }

Var
  Holder : String12;
  J      : Integer;
  Temp   : Char;

{ Variable Definitions }
{ Holder - used to build the encrypted phone number
  J      - Counter for a For loop
  Temp   - Used to build the encrypted phone number 1 character at a time }

Begin { Encrypt }
  Holder :='';
  For J := 1 to Length(PhoneNumber) do
  Begin  { String Parse }
    Temp := PhoneNumber[J];             { Gets the next character }
    Case Temp of
      '0' : Temp :='^';
      '1' : Temp :='Q';
      '2' : Temp :='y';              { Perform substitution }
      '3' : Temp :='%';
      '4' : Temp :='@';
      '5' : Temp :='j';
      '6' : Temp :='+';
      '7' : Temp :='E';
      '8' : Temp :=')';
      '9' : Temp :='.';
      '-' : Temp :='!';
      Else  Temp :=' ';
    End;    { Case Statement }
    Holder := Holder+Temp;              { Build String }
  End;   { String Parse }
  PhoneNumber := Holder; { Replace the phone number with encrypted version }
End; { Encrypt }

Procedure Decrypt (Var PhoneNumber : String12);
{ This procedure decrypts the phone number that is stored in the record.
  It has 3 local variables.                                               }
{ By Michael Cribbs }

Var
  Holder : String12;
  J      : Integer;
  Temp   : Char;

{ Variable Definitions }
{ Holder - used to build the decrypted phone number
  J      - Counter for a For loop
  Temp   - Used to build the decrypted phone number 1 character at a time }

Begin  { Decrypt }
  Holder :='';
  For J := 1 to Length(PhoneNumber) do
  Begin  { Parse String }
    Temp := PhoneNumber[J];    { Get next character }
    Case Temp of
      '^' : Temp :='0';
      'Q' : Temp :='1';
      'y' : Temp :='2';        { Perform substitution }
      '%' : Temp :='3';
      '@' : Temp :='4';
      'j' : Temp :='5';
      '+' : Temp :='6';
      'E' : Temp :='7';
      ')' : Temp :='8';
      '.' : Temp :='9';
      '!' : Temp :='-';
      ' ' : Temp :=' ';
    End; { Case Statement }
    Holder := Holder+Temp;     { Build string 1 character at a time }
  End; { Parse String }
  PhoneNumber := Holder;       { Replace with decrypted number }
End; { Decrypt }

Procedure CreateRecords (Var DataBase : DbaseType);
{ This procedure was used to create the database.  It is currently inactive.
  It has 3 local Variables. }

Var
  SexTest, YN : Char;
  I           : Integer;

{ Variable Definitions }
{ Sextest - Is the client male or female (M or F)
  YN      - Used for all the yes or no questions
  I       - COunter for the For loop                           }

Begin { CreateRecords }
    For I := 1 to MaxClients do
    With Database[I] do
    Begin               { With Loop }
      Clrscr;
      Write ('Enter Last Name:');
      ReadLn (LastName);
      Write ('Enter First Initial:');
      ReadLn (FirstName);
      Write ('Sex (M/F):');
      Read (SexTest);
      If Upcase(Sextest)='M' Then Sex := True
        Else Sex := False;
      Write ('Age :');
      ReadLn (Age);
      Write ('Height in Inches:');
      Readln (Height);
      Write ('Weight in Pounds:');
      Readln (Weight);
      Write ('Phone Number ex:916-688-7350 :');
      ReadLn (PhoneNumber);
      Encrypt (PhoneNumber);
      Write ('Rate Outdoors (1-5):');
      ReadLn (Outdoors);
      Write ('Rate Sports (1-5):');
      ReadLn (Sports);
      Write ('Rate Education (1-5):');
      ReadLn (Education);
      Write ('Rate Income (1-5):');
      ReadLn (Income);
      Write ('Rate Looks (1-5):');
      ReadLn (Looks);
      Write ('Rate Adventure (1-5):');
      ReadLn (Adventure);
      Write ('Rate Outgoing (1-5):');
      ReadLn (Outgoing);
      Write ('Easy to Get along with (Y/N):');
      ReadLn (YN);
      If Upcase(YN)='Y' Then Easy := True
        Else Easy := False;
      Write ('Do you drink (Y/N):');
      ReadLn (YN);
      If Upcase(YN)='Y' Then Drink := True
        Else Drink := False;
      Write ('Do you use drugs (Y/N):');
      ReadLn (YN);
      If Upcase(YN)='Y' Then Drugs := True
        Else Drugs := False;
      Write ('Do you smoke (Y/N):');
      ReadLn (YN);
      If Upcase(YN)='Y' Then Smoke := True
        Else Smoke := False;
        Write ('What type of music :');
        ReadLn (Music)
    End;  { With Loop }
End; { CreateRecords }

Procedure WriteRecords (Var Database : DbaseType);
{ This procedure writes out the database to the disk.  It is currently
  inactive.  It was used to creat the data file. It has 1 local variable }

Var
  I : Integer;

{ Variable Definitions }
{ I - Counter for the For loop }

Begin { WriteRecords }
  For I := 1 to MaxClients do
    Encrypt(DataBase[I].PhoneNumber);{ Encrypt phone numbers before storing }
  Rewrite (DatingFile);              { Open file for writing }
  For I := 1 to MaxClients do
    Write (DatingFile, DataBase[I]); { Write records to file }
  Close (DatingFile);                { Close File }
End; { WriteRecords }

Procedure ReadRecords (Var Database : DbaseType);
{ This procedure reads the database file from the disk and decrypts the
  phone numbers.  It has 1 local variable. }
{ By Michael Cribbs }

Var
  I : Integer;

{ Variable Definitions }
{ I - Counter for the For Loop }

Begin { ReadRecords }
  Reset (DatingFile);           { Open file for reading }
  For I := 1 to MaxClients do
    Read (DatingFile, DataBase[I]);  { Read in records into database }
  Close (DatingFile);                { Close file }
  For I := 1 to MaxClients do
    Decrypt(DataBase[I].PhoneNumber);{ Decrypt phone #'s in entire database }
End; { ReadRecords }

Procedure GetCriteria(Var Client : ClientType);
{"This procedure gets the criteria from the user that they want their date
to have."}
{ By Carol Luciano and Michael Cribbs}

Type
    CritArray = Array [1..15] of String12;
{ Type Description }
{ CritArray - An array of string[12] from 1 to 15 }

var
    sex1        :char;
    criteria, J :integer;
    flag        :boolean;
    CriteriaStr : CritArray;
{ Variable Descriptions }
{ Sex1        - Used for 1 character (Y or N or M or F) questions
  Criteria    - Criteria wanted for match
  J           - A loop variable
  Flag        - Boolean flag top make sure some data is entered
  CriteriaStr - An array holding the different criteria           }

Procedure ClearVar (Var UsedCriteria : Matches);
{ This procedure clears variables and sets them to default values }

Var
  I : Integer;

Begin { ClearVar }
  For I := 1 to 15 Do
    UsedCriteria[I] := False;
    CriteriaStr[1] := 'Age';
    CriteriaStr[2] := 'Height';
    CriteriaStr[3] := 'Weight';
    CriteriaStr[4] := 'OutDoors';
    CriteriaStr[5] := 'Sports';
    CriteriaStr[6] := 'Education';
    CriteriaStr[7] := 'Income';
    CriteriaStr[8] := 'Looks';
    CriteriaStr[9] := 'Adventurous';
    CriteriaStr[10] := 'Outgoing';
    CriteriaStr[11] := 'Into Leather';
    CriteriaStr[12] := 'Drink';
    CriteriaStr[13] := 'Smoke';
    CriteriaStr[14] := 'Drugs';
    CriteriaStr[15] := 'Music';
End; {ClearVar}

Procedure WriteNumber(J : Integer);
{ Writes a number in red on the screen }

Begin {WriteNumber}
  TextColor(Red);
  Write(J:2);
  TextColor(Yellow);
  Write(' - ');
End; {WriteNumber}

begin { GetCriteria }
   ClrScr;
   ClearVar(UsedCriteria);
   Repeat
     write('Please enter your sex(m/f):  ');
     readln(sex1);
     If Not (Upcase(Sex1) in ['M', 'F']) Then
       writeln('Invalid sex type.  Please reenter your sex(m/f): ');
    Until (sex1 in ['M', 'm', 'F', 'f']);
    Client.Sex := (Upcase(Sex1) = 'M');
    flag := false;
    With Client Do
    Repeat
    Clrscr;
    GotoXY(1,4);
    writeln('Please enter the criteria you wish to search.  You may select ');
    writeln('as many as you like.  However, you must ENTER ONE at a time ');
    writeln('and you must ENTER AT LEAST ONE to begin the search');
    writeln;
    For J := 1 to 15 Do
    Begin { For }
      WriteNumber(J);
      Write (CriteriaStr[J]:12, ' ');
      If J Mod 4 = 0 Then WriteLn;
    End; { For }
    WriteLn;
    TextColor(Black);
    writeln('TO END THE SEARCH ENTER 0 or A NEGATIVE NUMBER!');
    Write(':');
    readln(criteria);
    case criteria of
    1  : Begin  { 1 }
         write('Enter the desired age: ');
         readln(age);
         UsedCriteria[1] := true;
         flag := true;
         end; { 1 }
    2  : Begin { 2 }
         write('Enter the desired height(inches): ');
         readln(height);
         UsedCriteria[2] := true;
         flag := true;
         end; { 2 }
    3  : Begin { 3 }
         write('Enter the desired weight(pounds): ');
         readln(weight);
         UsedCriteria[3] := true;
         flag := true;
         end; { 3 }
    4  : Begin { 4 }
         write('Enter a number from 1 to 5 :(1-least to 5-most important)');
         readln(outdoors);
         UsedCriteria[4] := true;
         flag := true;
         end;  { 4 }
    5  : Begin { 5 }
         write('Enter a number from 1 to 5 :(1-least to 5-most important)');
         readln(sports);
         UsedCriteria[5] := true;
         flag := true;
         end; { 5 }
    6  : Begin { 6 }
         write('Enter a number from 1 to 5 (1-least to 5-most important)');
         readln(education);
         UsedCriteria[6] := true;
         flag := true;
         end; { 6 }
    7  : Begin { 7 }
         write('Enter a number from 1 to 5 :(1-least to 5-most important)');
         readln(income);
         UsedCriteria[7] := true;
         flag := true;
         end; { 7 }
    8  : Begin { 8 }
         write('Enter a number from 1 to 5 :(1-least to 5-most important)');
         readln(looks);
         UsedCriteria[8] := true;
         flag := true;
         end; { 8 }
    9  : Begin { 9 }
         write('Enter a number from 1 to 5 :(1-least to 5-most important)');
         readln(adventure);
         UsedCriteria[9] := true;
         flag := true;
         end; { 9 }
    10 : Begin { 10 }
         write('Enter a number from 1 to 5 :(1-least to 5-most important)');
         readln(outgoing);
         UsedCriteria[10] := true;
         flag := true;
         end; { 10 }
    11 : Begin { 11 }
         write('Do you want a person that is into leather(y or n)');
         Readln(Sex1);
         easy := (Upcase(Sex1) = 'Y');
         UsedCriteria[11] := true;
         flag := true;
         end; { 11 }
    12 : Begin { 12 }
         write('Do you want a person that drinks(y or n)');
         Readln(Sex1);
         Drink := (Upcase(Sex1) = 'Y');
         UsedCriteria[12] := true;
         flag := true;
         end; { 12 }
    13 : Begin { 13 }
         write('Do you want a person that smokes(y or n)');
         Readln(Sex1);
         Smoke := (Upcase(Sex1) = 'Y');
         UsedCriteria[13] := true;
         flag := true;
         end; { 13 }
    14 : Begin { 14 }
         write('Do you want a person that uses drugs(y or n)');
         Readln(Sex1);
         Drugs := (Upcase(Sex1) = 'Y');
         UsedCriteria[14] := true;
         flag := true;
         end; { 14 }
    15 : Begin { 15 }
         writeLn('Enter the number for the type of music he/she should like ');
         write('1-rock n roll, 2-top 40''s, 3-country/western, 4-classical, ');
         write('and 5-other:');
         readln(music);
         UsedCriteria[15] := true;
         flag := true;
         end; { 15 }
    end;  {case of criteria}
    until (flag = true) and (criteria <= 0)         {exit case statement}
End; { GetCriteria }



Procedure SearchDataBase(Var DataBase: DBaseType; Var Client:Dating;
                     Var UsedCriteria, ClientMatches:Matches);
   {Search for a match that meet the chosen criteria. }
   { By Andy Mok }

Var
   GotAMatch: Boolean;                 {Flag to see if there is a match   }
   I: Integer;                         {Counter of a For loop             }
   J: Integer;                         {Counter of a For loop             }
   Count: Integer;                     {Count how many criteria was match }
   NumberUsed: Integer;                {The no. of criteria choose by user}
   Redo : Char;

Begin {SearchData}
  Write ('Searching');
  GotAMatch := False;
  For I := 1 to 20 do
  Begin {I loop}
    Count := 0;
    NumberUsed := 0;
    If Client.Sex = DataBase[I].Sex then Write('.')
    Else
    Begin {Else}
      For J := 1 to 15 do
      Begin {J loop}
        If UsedCriteria[J] then
        Begin {If}
          NumberUsed := NumberUsed + 1;
          Case J of
            1 : If Client.Age = Database[I].Age then Count := Count +1;
            2 : If Client.Height = Database[I].Height then Count := Count +1;
            3 : If Client.Weight = Database[I].Weight then Count := Count +1;
            4 : If Client.Outdoors = Database[I].Outdoors then Count := Count +1;
            5 : If Client.Sports = Database[I].Sports then Count := Count +1;
            6 : If Client.Education = Database[I].Education then Count := Count +1;
            7 : If Client.Income = Database[I].Income then Count := Count +1;
            8 : If Client.Looks = Database[I].Looks then Count := Count +1;
            9 : If Client.Adventure = Database[I].Adventure then Count := Count +1;
           10 : If Client.Outgoing = Database[I].Outgoing then Count := Count +1;
           11 : If Client.Easy = Database[I].Easy then Count := Count +1;
           12 : If Client.Drink = Database[I].Drink then Count := Count +1;
           13 : If Client.Smoke = Database[I].Smoke then Count := Count +1;
           14 : If Client.Drugs = Database[I].Drugs then Count := Count +1;
           15 : If Client.Music = Database[I].Music then Count := Count +1;
          End; {Case}
        End; {If}
      End; {J loop}
    End; {Else}
    If (NumberUsed = Count) and (NumberUsed<>0) then
    Begin {If}
      ClientMatches[I] := True;
      GotAMatch := True;
      Flag := True;
      Rerun := False
    End; {If}
  End; {I loop}
  If Not GotAMatch Then
  Begin {If}
    WriteLn;
    TextColor(20);
    Writeln ('Did not get any matches!');
    Flag := False;
    TextColor(Black);
    Redo :=' ';
    Repeat
        Write ('Enter Criteria Again (Y or N):');
        Readln(Redo);
        If Upcase(Redo)='Y' Then Rerun:=True
        Else
          If Upcase(Redo)='N' Then Rerun := False;
    Until Redo in ['Y', 'N', 'y', 'n'];
  End; {If}
End; {SearchData}

Procedure DisplayRecords (Var OneRecord : Dating; Index: integer);
{ This procedure displays the record of the passed parameter Index.
  For example if Index = 4 it displays DataBase[4].  This procedure has
  2 local procedures: EvalCriteria and MoveCursor, 3 local variables, and
  1 local Type. }
{ By Michael Cribbs and Ben Weir }

Type
  LongString = String[80];

{ Type Declarations }
{ LongString - 80 character long string }

Var
  I      : Integer;
  Holder : LongString;
  A      : Char;

{ Variable Definitions }
{ I      - Counter for the For loop.
  Holder - Used to hold the different criteria strings for output.
  A      - Holds a pressed key (to pause the screen)               }

Procedure EvalCriteria (Var Variable : Fiver; Var Holder : LongString;
                        Flag : Fiver);
{ This procedure gives meaning to the 1 through 5 settings in the records.
  It puts in Holder a more descriptive answer than the number.  This local
  procedure has 5 local procedures of its own: One, Two, Three, Four, Five }

Procedure One (Var Variable : Fiver; Var Holder : LongString);
{ This procedure is for category 1 criteria: Outdoors, Sports, Adventure,
  and Outgoing. }

Begin { One }
  Case Variable of
    1 : Holder := 'None';
    2 : Holder := 'Little';
    3 : Holder := 'Some';
    4 : Holder := 'Very';
    5 : Holder := 'Extremely';
  End; { Case Statement }
End;  { One }

Procedure Two (Var Variable : Fiver; Var Holder : LongString);
{ This procedure is for category 2 criteria: Eductaion }

Begin { Two }
  Case Variable of
    1 : Holder := 'Less than High School';
    2 : Holder := 'High School Graduate';
    3 : Holder := 'Some College';
    4 : Holder := 'College Degree';
    5 : Holder := 'Graduate Degree';
  End; { Case Statement }
End; { Two }

Procedure Three (Var Variable : Fiver; Var Holder : LongString);
{ This procedure is for category 3 criteria: Income }

Begin { Three }
  Case Variable of
    1 : Holder := 'Less than $7,500';
    2 : Holder := '$7,500 - $15,000';
    3 : Holder := '$15,001 - $25,000';
    4 : Holder := '$25,001 - $40,000';
    5 : Holder := 'Over $40,000';
  End; { Case Statement }
End; { Three }

Procedure Four (Var Variable : Fiver; Var Holder : LongString);
{ This procedure is for category 4 criteria: Looks }

Begin { Four }
  Case Variable of
    1 : Holder := 'Ugly';
    2 : Holder := 'Below Average';
    3 : Holder := 'Average';
    4 : Holder := 'Above Average';
    5 : Holder := 'To die for!';
  End; { Case Statement }
End; { Four }

Procedure Five (Var Variable : Fiver; Var Holder : LongString);
{ This procedure is for category 5 criteria: Music }

Begin { Five }
  Case Variable of
    1 : Holder := 'Rock ''N'' Roll';
    2 : Holder := 'Top 40';
    3 : Holder := 'Country and Western';
    4 : Holder := 'Classical';
    5 : Holder := 'Other';
  End; { Case Statement }
End; { Five }

Begin  { EvalCriteria }
  Case Flag of  { Uses passed constant to determine which category to use }
    1 : One (Variable, Holder);
    2 : Two (Variable, Holder);
    3 : Three (Variable, Holder);
    4 : Four (Variable, Holder);
    5 : Five (Variable, Holder);
  End; { Case Statement }
End; { EvalCriteria }

Procedure MoveCursor;
{ This procedure moves the cursor to the 25th column and prints a ':'.
  It has 1 local variable. }

Var
  Y : Integer;

{ Variable Definitions }
{ Y - What line the cursor is on }

Begin { MoveCursor }
  Y := WhereY;    { Store what line the cursor is on in Y }
  GoToXY (25,Y);  { Move cursor on that line to 25th column }
  Write (':');
End; { MoveCursor }

Begin { DisplayRecords }
  With OneRecord do
  Begin     { With Loop }
    TextBackground (11);
    ClrScr;
    Textcolor(yellow);
    WriteLn ('       DateMaker 2000 for Selective Singles');
    Textcolor(0);
    WriteLn;

    If index >=1 then
      begin
      Write('Client Number');
      MoveCursor;
      TextColor(4);
      WriteLn (Index);
      TextColor(0);
      end;
    Write ('Last Name');
    MoveCursor;
    TextColor(4);
    WriteLn (LastName);
    TextColor(0);
    Write ('First Initial');
    MoveCursor;
    TextColor(4);
    WriteLn (FirstName);
    TextColor(0);
    Write ('Sex');
    MoveCursor;
    TextColor(4);
    If Sex Then WriteLn ('Male')
      Else WriteLn ('Female');
    TextColor(0);
    Write ('Age');
    MoveCursor;
    TextColor(4);
    WriteLn (Age);
    TextColor(0);
    Write ('Height');
    MoveCursor;
    TextColor(4);
    Write (Height);                      {I made so if they are 1 inch tall}
    TextColor(0);                        {or weigh 1 pound it uses proper  }
    Write (' Inch');                     {grammar: no 's' since it's only 1}
    if Height > 1 then write('es');
    Writeln;
    Write ('Weight');
    MoveCursor;
    TextColor(4);
    Write (Weight);
    TextColor(0);
    Write (' Pound');
    if Weight > 1 then write('s');
    Writeln;
    Write ('Phone Number');
    MoveCursor;
    TextColor(4);
    WriteLn (PhoneNumber);
    TextColor(0);
    EvalCriteria(Outdoors, Holder, 1);
    Write ('Interest in Outdoors');
    MoveCursor;
    TextColor(4);
    WriteLn (Holder);
    TextColor(0);
    EvalCriteria(Sports, Holder, 1);
    Write ('Interest in Sports');
    MoveCursor;
    TextColor(4);
    WriteLn (Holder);
    TextColor(0);
    EvalCriteria(Education, Holder,2);
    Write ('Education Level');
    MoveCursor;
    TextColor(4);
    WriteLn (Holder);
    TextColor(0);
    EvalCriteria(Income, Holder,3);
    Write ('Income');
    MoveCursor;
    TextColor(4);
    WriteLn (Holder);
    TextColor(0);
    EvalCriteria(Looks, Holder,4);
    Write ('Physical Attractiveness');
    MoveCursor;
    TextColor(4);
    WriteLn (Holder);
    TextColor(0);
    EvalCriteria(Adventure, Holder,1);
    Write ('How Adventurous they are');
    MoveCursor;
    TextColor(4);
    WriteLn (Holder);
    TextColor(0);
    EvalCriteria(OutGoing, Holder,1);
    Write ('How Outgoing they are');
    MoveCursor;
    TextColor(4);
    WriteLn (Holder);
    TextColor(0);
    Write ('Into leather');
    MoveCursor;
    TextColor(4);
    If Easy then WriteLn ('Yes')
      Else WriteLn ('No');
    TextColor(0);
    Write ('Drinks');
    MoveCursor;
    TextColor(4);
    If Drink then WriteLn ('Yes')
      Else WriteLn ('No');
    TextColor(0);
    Write ('Uses Drugs');
    MoveCursor;
    TextColor(4);
    If Drugs then WriteLn ('Yes')
      Else WriteLn ('No');
    TextColor(0);
    Write ('Smokes');
    MoveCursor;
    TextColor(4);
    If Smoke then WriteLn ('Yes')
      Else WriteLn ('No');
    TextColor(0);
    EvalCriteria (Music, Holder,5);
    Write ('Listens to');
    MoveCursor;
    TextColor(4);
    WriteLn (Holder);
    TextColor(17);
    Write ('                    Hit a key to continue');
    A := ReadKey;
    TextColor(0);
    ClrScr;
  End; { With Loop }
End; { DisplayRecords }


Procedure RestoreScreen;
{ This procedure restores the original screen and text colors back }
{ By Michael Cribbs }

Begin { RestoreScreen }
  NormVideo;
  Clrscr;
End;  { RestoreScreen }

Procedure GetClientInfo(var Client: ClientType; Choice: ChoiceText);
{This procedure gets all the information about the client who is using
the program to search for a suitable date.

  Input -  The record that will contain the info.
  Output - The record with all the info in it.

There are two functions within this procedure:
  GetFiver - Gets a number between 1 and 5
  GetYN    - Gets either 'Y' or 'N'

There is one procedure withing this procedure:
  ShowChoices - Displays a menu in the upper right corner of the screen that
                tells user what the numbers (1-5) mean.
There are two constants:
  Blank - holds spaces to erase an invalid entry by the user
  Tab   - Screen position where the data is input

There is one local variable:
  SexTest - Stores 'M' or 'F' before it gets converted to true or false }
{ By Ben Weir }

const
  blank='                      ';  {used to erase an invalid entry and menu}
  Tab=34;                          {used to align data entry}
  Blank2 = '     ';
var
  SexTest: Char;

  {{{{{{{{{{{{{{{{{}
Function GetFiver(Index: integer):fiver;
var
  temp: fiver;
begin                                   {this function gets a number 1-5}
  Repeat                                {from the user}
    GotoXY(Tab, index);
    Write(blank);
    GotoXY(Tab, index);
    ReadLn(temp);
  until (temp >=1) and (temp <=5);
  GetFiver := temp;
  GotoXY(Tab, index);
end;
  {{{{{{{{{{{{{{{{{}
Function GetYN(Index: integer):boolean;
var
  temp: char;
begin                                     {this function gets a (Y/N) answer}
  Repeat                                  {from the user}
    GotoXY(Tab, index);
    Write(blank);
    GotoXY(Tab, index);
    ReadLn(temp);
    temp := Upcase(temp);
  until (Temp = 'Y') or (temp = 'N');   {change 'y' to 'Yes' and 'n' to 'No'}
  GotoXY(Tab, index);
  If Temp = 'Y' then write('Yes')
    Else write('No');
  GetYN := (Temp = 'Y');
end;
  {{{{{{{{{{{{{{{{{}

Procedure ShowChoices(Choice: ChoiceList);
var
  x: integer;                              {this procedure shows what the}
                                           {choices 1-5 mean}
begin
  TextColor(Yellow);
  For x := 1 to 5 do
  begin
    GotoXY(48, x);
    If length(Choice[x]) > 0 then Write (x, '. ');
    If Length(Choice[X])<12 Then
      Write(Choice[x], blank)
    Else
      Write (Choice[X], Blank2);
  end;
    TextColor(Black);
end;

{This displays all the fields the client must fill out, then
 gets input for each one.  when all are filled out, it asks
 if the data is correct.  If it's not, it gets all the input again}
begin
  with Client do
  Begin               { With Loop }
    Repeat
      Clrscr;
      Writeln ('                Enter Last Name:');
      Writeln ('            Enter First Initial:');
      Writeln ('                      Sex (M/F):');
      Writeln ('                            Age:');
      Writeln ('               Height in Inches:');
      Writeln ('               Weight in Pounds:');
      Writeln ('Phone Number (ex. 916-688-7350):');
      Writeln ('            Rate Outdoors (1-5):');
      Writeln ('              Rate Sports (1-5):');
      Writeln ('           Rate Education (1-5):');
      Writeln ('              Rate Income (1-5):');
      Writeln ('               Rate Looks (1-5):');
      Writeln ('           Rate Adventure (1-5):');
      Writeln ('            Rate Outgoing (1-5):');
      Writeln ('             Into Leather (Y/N):');
      Writeln ('             Do you drink (Y/N):');
      Writeln ('         Do you use drugs (Y/N):');
      Writeln ('             Do you smoke (Y/N):');
      Writeln ('       What type of music (1-5):');

      GotoXY(Tab,1);
      ReadLn (LastName);

      GotoXY(Tab,2);
      ReadLn (FirstName);

      Repeat
        GotoXY(Tab,3);
        Write(blank);
        GotoXY(Tab,3);
        Read (SexTest);
        SexTest := UpCase(Sextest);
        GotoXY(Tab,3);
        If Sextest = 'M' Then
        begin
          Sex := True;
          write('Male');
        end
        Else
        begin
          Sex := False;
          Write('Female');
        end;

      until (SexTest = 'M') or (SexTest = 'F');

      Repeat
        GotoXY(Tab,4);
        Write(blank);
        GotoXY(Tab,4);
        ReadLn (Age);
      Until (Age >= 1) and (Age <= 118);

      Repeat
        GotoXY(Tab,5);
        Write(blank);
        GotoXY(Tab,5);
        Readln (Height);
      Until (Height >= 1) and (Height <=96);

      Repeat
        GotoXY(Tab,6);
        Write(blank);
        GotoXY(Tab,6);
        Readln (Weight);
      Until (Weight >= 1) and (Weight <= 1000);

      GotoXY(Tab,7);
      ReadLn (PhoneNumber);
      {Encrypt (PhoneNumber);}

      ShowChoices(Choice.Rating);
      OutDoors := GetFiver(8);
      Write(Choice.Rating[Outdoors]);

      Sports := GetFiver(9);
      Write(Choice.Rating[Sports]);

      ShowChoices(Choice.Education);
      Education := GetFiver(10);
      Write(Choice.Education[Education]);

      ShowChoices(Choice.Income);
      Income := GetFiver(11);
      Write(Choice.Income[Income]);

      ShowChoices(Choice.Looks);
      Looks := GetFiver(12);
      Write(Choice.Looks[Looks]);

      ShowChoices(Choice.Rating);
      Adventure := GetFiver(13);
      Write(Choice.Rating[Adventure]);

      OutGoing := GetFiver(14);
      Write(Choice.Rating[Outgoing]);

      ShowChoices(Choice.Empty);    {erase leftover menu}

      Easy := GetYN(15);
      Drink := GetYN(16);
      Drugs := GetYN(17);
      Smoke := GetYN(18);

      ShowChoices(Choice.Music);
      Music := GetFiver(19);
      Write(Choice.Music[Music]);

      ShowChoices(Choice.Empty);    {erase leftover menu}

      GotoXY(1, 22);                                  {confirm data validity}
      TextColor(1);
      Write ('  Is all the above correct (Y/N):');
      TextColor(0);

    Until GetYN(22);      {loop until they answer 'Y'}
  end;
end;

procedure SearchForMatch(var DataBase:  DbaseType; var client:  ClientType;
                         var ClientMatches:  matches);
{this procedure will perform a search of the database to see if there is a
 best match}
{ By Eric Young }

{local variables}

var
  I,HighMatches,MatchNumber,match:         integer;
  NumberOfMatches : array[1..20] of integer;

begin{SearchForMatch}
match := 0;
  for I := 1 to 20 do
    begin{for}
    if client.sex <> DataBase[I].sex then
      begin{while}
        if client.age = database[I].age then match := match + 1;
        if client.outdoors = database[I].outdoors then match := match + 1;
        if client.sports = database[I].sports then match := match + 1;
        if client.education = database[I].education then match := match + 1;
        if client.income = database[I].income then match := match + 1;
        if client.looks = database[I].looks then match := match + 1;
        if client.adventure = database[I].adventure then match := match + 1;
        if client.outgoing = database[I].outgoing then match := match + 1;
        if client.easy = database[I].easy then match := match + 1;
        if client.drink = database[I].drink then match := match + 1;
        if client.smoke = database[I].smoke then match := match + 1;
        if client.drugs = database[I].drugs then match := match + 1;
        if client.music = database[I].music then match := match + 1;
      end;{while}
    NumberOfMatches[I] := match;
    match := 0;
    end;{for}

  HighMatches := 0;

  for I := 1 to 20 do
    begin{for}
      ClientMatches[I] := false;
      if HighMatches < NumberOfMatches[I] then
        begin{if}
          HighMatches:=NumberOfMatches[I];
          MatchNumber := I;
        end;{if}
    end;{for}

  ClientMatches[MatchNumber] := True;

end;{SearchForMatch}
Var
  Generic : Integer;
Procedure WhatKind;
Begin
  Repeat
  WriteLn;
  WriteLn;
  WriteLn;
  WriteLn ('Do you want to do a best match search or a search by criteria');
  Write ('Enter: ');
  TextColor(4);
  Write ('1 ');
  TextColor(0);
  WriteLn ('to do a best match search');
  Write ('       ');
  TextColor(4);
  Write('2 ');
  TextColor(0);
  WriteLn('to do a criteria search');
  Write(':');
  ReadLn (Generic);
  If Generic = 1 Then ClientSearch := True
    Else
      If Generic = 2 Then ClientSearch := False
        Else
          WriteLn('Invalid Entry!');
  Until (Generic = 1) or (Generic = 2);
End;

Procedure DisplayMatches(Database: DbaseType; Client: clienttype;
                         ClientMatches: matches);
{ By Ben Weir }

var
  i: integer;

begin { DisplayMatches }
  for i := 1 to 20 do
  begin { For }
    if ClientMatches[i] = True then DisplayRecords(DataBase[i], i);
  end; { For }
end;  { DisplayMatches }

{ Main Program }

Begin { Main Program }
  GetReady;
  ReadRecords(DataBase);
  WhatKind;
  If ClientSearch then
   Begin {If ClientSearch = True}
     GetClientInfo(Client, Choice);
     SearchForMatch(DataBase, Client, ClientMatches);
   End   {If ClientSearch = True}
  Else
    Begin { If False }
      Repeat
        GetCriteria(Client);
        SearchDataBase(DataBase, Client, UsedCriteria, ClientMatches)
      Until Rerun = False;
    End;  { If False }
  If Flag Then DisplayMatches(DataBase, Client, ClientMatches);
  RestoreScreen;
End. { Main Program }

{ Space for Instructors Comments:
                                                                   }